> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/nemo-platform/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.nvidia.com/nemo-platform/_mcp/server.

# Upload OTLP Logs to Fileset

POST /apis/files/v2/workspaces/{workspace}/filesets/{name}/otlp/v1/logs

Upload OTLP logs to a specified fileset in JSON or Protobuf format.

Supports both application/json and application/x-protobuf content types.

Reference: https://docs.nvidia.com/nemo-platform/documentation/reference/api-reference/otlp/upload-otlp-logs-apis-files-v-2-workspaces-workspace-filesets-name-otlp-v-1-logs-post

## Request

### Path parameters

- `workspace` (string, required)
- `name` (string, required)

### Query parameters

- `artifact_base_path` (string, optional) — Folder inside the fileset to nest logs under

## Response

### 200

Successful Response

- `partialSuccess` (object, optional) — Partial success response details.
  - `rejectedLogRecords` (integer, optional, default: 0) — Number of rejected log records
  - `errorMessage` (string, optional) — Human-readable error message

## Examples

**Request**

```json
{
  "resourceLogs": [
    {
      "resource": {
        "attributes": [
          {
            "key": "service.name",
            "value": {
              "stringValue": "payment-service"
            }
          },
          {
            "key": "host.name",
            "value": {
              "stringValue": "host-1234"
            }
          }
        ]
      },
      "scopeLogs": [
        {
          "logRecords": [
            {
              "attributes": [
                {
                  "key": "user.id",
                  "value": {
                    "stringValue": "user-789"
                  }
                },
                {
                  "key": "session.id",
                  "value": {
                    "stringValue": "session-456"
                  }
                }
              ],
              "body": {
                "stringValue": "User login successful"
              },
              "severityNumber": 9,
              "severityText": "Info",
              "timeUnixNano": "1687507200000000000"
            }
          ],
          "scope": {
            "name": "otel.library.logs",
            "version": "1.0.0"
          }
        }
      ]
    }
  ]
}
```

**Response**

```json
{
  "partialSuccess": {
    "rejectedLogRecords": 0,
    "errorMessage": ""
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.example.com/apis/files/v2/workspaces/workspace/filesets/name/otlp/v1/logs"

payload = { "resourceLogs": [
        {
            "resource": { "attributes": [
                    {
                        "key": "service.name",
                        "value": { "stringValue": "payment-service" }
                    },
                    {
                        "key": "host.name",
                        "value": { "stringValue": "host-1234" }
                    }
                ] },
            "scopeLogs": [
                {
                    "logRecords": [
                        {
                            "attributes": [
                                {
                                    "key": "user.id",
                                    "value": { "stringValue": "user-789" }
                                },
                                {
                                    "key": "session.id",
                                    "value": { "stringValue": "session-456" }
                                }
                            ],
                            "body": { "stringValue": "User login successful" },
                            "severityNumber": 9,
                            "severityText": "Info",
                            "timeUnixNano": "1687507200000000000"
                        }
                    ],
                    "scope": {
                        "name": "otel.library.logs",
                        "version": "1.0.0"
                    }
                }
            ]
        }
    ] }
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.example.com/apis/files/v2/workspaces/workspace/filesets/name/otlp/v1/logs';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json'},
  body: '{"resourceLogs":[{"resource":{"attributes":[{"key":"service.name","value":{"stringValue":"payment-service"}},{"key":"host.name","value":{"stringValue":"host-1234"}}]},"scopeLogs":[{"logRecords":[{"attributes":[{"key":"user.id","value":{"stringValue":"user-789"}},{"key":"session.id","value":{"stringValue":"session-456"}}],"body":{"stringValue":"User login successful"},"severityNumber":9,"severityText":"Info","timeUnixNano":"1687507200000000000"}],"scope":{"name":"otel.library.logs","version":"1.0.0"}}]}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.example.com/apis/files/v2/workspaces/workspace/filesets/name/otlp/v1/logs"

	payload := strings.NewReader("{\n  \"resourceLogs\": [\n    {\n      \"resource\": {\n        \"attributes\": [\n          {\n            \"key\": \"service.name\",\n            \"value\": {\n              \"stringValue\": \"payment-service\"\n            }\n          },\n          {\n            \"key\": \"host.name\",\n            \"value\": {\n              \"stringValue\": \"host-1234\"\n            }\n          }\n        ]\n      },\n      \"scopeLogs\": [\n        {\n          \"logRecords\": [\n            {\n              \"attributes\": [\n                {\n                  \"key\": \"user.id\",\n                  \"value\": {\n                    \"stringValue\": \"user-789\"\n                  }\n                },\n                {\n                  \"key\": \"session.id\",\n                  \"value\": {\n                    \"stringValue\": \"session-456\"\n                  }\n                }\n              ],\n              \"body\": {\n                \"stringValue\": \"User login successful\"\n              },\n              \"severityNumber\": 9,\n              \"severityText\": \"Info\",\n              \"timeUnixNano\": \"1687507200000000000\"\n            }\n          ],\n          \"scope\": {\n            \"name\": \"otel.library.logs\",\n            \"version\": \"1.0.0\"\n          }\n        }\n      ]\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.example.com/apis/files/v2/workspaces/workspace/filesets/name/otlp/v1/logs")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n  \"resourceLogs\": [\n    {\n      \"resource\": {\n        \"attributes\": [\n          {\n            \"key\": \"service.name\",\n            \"value\": {\n              \"stringValue\": \"payment-service\"\n            }\n          },\n          {\n            \"key\": \"host.name\",\n            \"value\": {\n              \"stringValue\": \"host-1234\"\n            }\n          }\n        ]\n      },\n      \"scopeLogs\": [\n        {\n          \"logRecords\": [\n            {\n              \"attributes\": [\n                {\n                  \"key\": \"user.id\",\n                  \"value\": {\n                    \"stringValue\": \"user-789\"\n                  }\n                },\n                {\n                  \"key\": \"session.id\",\n                  \"value\": {\n                    \"stringValue\": \"session-456\"\n                  }\n                }\n              ],\n              \"body\": {\n                \"stringValue\": \"User login successful\"\n              },\n              \"severityNumber\": 9,\n              \"severityText\": \"Info\",\n              \"timeUnixNano\": \"1687507200000000000\"\n            }\n          ],\n          \"scope\": {\n            \"name\": \"otel.library.logs\",\n            \"version\": \"1.0.0\"\n          }\n        }\n      ]\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.example.com/apis/files/v2/workspaces/workspace/filesets/name/otlp/v1/logs")
  .header("Content-Type", "application/json")
  .body("{\n  \"resourceLogs\": [\n    {\n      \"resource\": {\n        \"attributes\": [\n          {\n            \"key\": \"service.name\",\n            \"value\": {\n              \"stringValue\": \"payment-service\"\n            }\n          },\n          {\n            \"key\": \"host.name\",\n            \"value\": {\n              \"stringValue\": \"host-1234\"\n            }\n          }\n        ]\n      },\n      \"scopeLogs\": [\n        {\n          \"logRecords\": [\n            {\n              \"attributes\": [\n                {\n                  \"key\": \"user.id\",\n                  \"value\": {\n                    \"stringValue\": \"user-789\"\n                  }\n                },\n                {\n                  \"key\": \"session.id\",\n                  \"value\": {\n                    \"stringValue\": \"session-456\"\n                  }\n                }\n              ],\n              \"body\": {\n                \"stringValue\": \"User login successful\"\n              },\n              \"severityNumber\": 9,\n              \"severityText\": \"Info\",\n              \"timeUnixNano\": \"1687507200000000000\"\n            }\n          ],\n          \"scope\": {\n            \"name\": \"otel.library.logs\",\n            \"version\": \"1.0.0\"\n          }\n        }\n      ]\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.example.com/apis/files/v2/workspaces/workspace/filesets/name/otlp/v1/logs', [
  'body' => '{
  "resourceLogs": [
    {
      "resource": {
        "attributes": [
          {
            "key": "service.name",
            "value": {
              "stringValue": "payment-service"
            }
          },
          {
            "key": "host.name",
            "value": {
              "stringValue": "host-1234"
            }
          }
        ]
      },
      "scopeLogs": [
        {
          "logRecords": [
            {
              "attributes": [
                {
                  "key": "user.id",
                  "value": {
                    "stringValue": "user-789"
                  }
                },
                {
                  "key": "session.id",
                  "value": {
                    "stringValue": "session-456"
                  }
                }
              ],
              "body": {
                "stringValue": "User login successful"
              },
              "severityNumber": 9,
              "severityText": "Info",
              "timeUnixNano": "1687507200000000000"
            }
          ],
          "scope": {
            "name": "otel.library.logs",
            "version": "1.0.0"
          }
        }
      ]
    }
  ]
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.example.com/apis/files/v2/workspaces/workspace/filesets/name/otlp/v1/logs");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"resourceLogs\": [\n    {\n      \"resource\": {\n        \"attributes\": [\n          {\n            \"key\": \"service.name\",\n            \"value\": {\n              \"stringValue\": \"payment-service\"\n            }\n          },\n          {\n            \"key\": \"host.name\",\n            \"value\": {\n              \"stringValue\": \"host-1234\"\n            }\n          }\n        ]\n      },\n      \"scopeLogs\": [\n        {\n          \"logRecords\": [\n            {\n              \"attributes\": [\n                {\n                  \"key\": \"user.id\",\n                  \"value\": {\n                    \"stringValue\": \"user-789\"\n                  }\n                },\n                {\n                  \"key\": \"session.id\",\n                  \"value\": {\n                    \"stringValue\": \"session-456\"\n                  }\n                }\n              ],\n              \"body\": {\n                \"stringValue\": \"User login successful\"\n              },\n              \"severityNumber\": 9,\n              \"severityText\": \"Info\",\n              \"timeUnixNano\": \"1687507200000000000\"\n            }\n          ],\n          \"scope\": {\n            \"name\": \"otel.library.logs\",\n            \"version\": \"1.0.0\"\n          }\n        }\n      ]\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = ["resourceLogs": [
    [
      "resource": ["attributes": [
          [
            "key": "service.name",
            "value": ["stringValue": "payment-service"]
          ],
          [
            "key": "host.name",
            "value": ["stringValue": "host-1234"]
          ]
        ]],
      "scopeLogs": [
        [
          "logRecords": [
            [
              "attributes": [
                [
                  "key": "user.id",
                  "value": ["stringValue": "user-789"]
                ],
                [
                  "key": "session.id",
                  "value": ["stringValue": "session-456"]
                ]
              ],
              "body": ["stringValue": "User login successful"],
              "severityNumber": 9,
              "severityText": "Info",
              "timeUnixNano": "1687507200000000000"
            ]
          ],
          "scope": [
            "name": "otel.library.logs",
            "version": "1.0.0"
          ]
        ]
      ]
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.example.com/apis/files/v2/workspaces/workspace/filesets/name/otlp/v1/logs")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```